#define STANDBY  30

#define INA1    28
#define INA2    26
#define PWMA    5

#define INB1    32
#define INB2    34
#define PWMB    6

const byte TRIGGER_PIN = 22; // Broche TRIGGER
const byte ECHO_PIN = 24; // Broche ECHO  
int distmin = 10;
const float SOUND_SPEED = 340.0 / 1000;
int led= 12;


void setup(void){
  Serial.begin(9600);
pinMode(STANDBY,OUTPUT);
pinMode(INA1,OUTPUT);
pinMode(INA2,OUTPUT);
pinMode(PWMA,OUTPUT);
pinMode(INB1,OUTPUT);
pinMode(INB2,OUTPUT);
pinMode(PWMB,OUTPUT);
pinMode(TRIGGER_PIN, OUTPUT);
pinMode(led, OUTPUT);
pinMode(ECHO_PIN, INPUT);
}

void loop(void){
 //prog ultrason
 digitalWrite(TRIGGER_PIN, LOW); 
 delayMicroseconds(2);
 /* 1. Lance une mesure de distance en envoyant une impulsion HIGH de 10µs sur la broche TRIGGER */
 digitalWrite(TRIGGER_PIN, HIGH);
 delayMicroseconds(10);
 digitalWrite(TRIGGER_PIN, LOW);
 digitalWrite(led, LOW);
 /* 2. Mesure le temps entre l'envoi de l'impulsion ultrasonique et son écho (si il existe) */
 long measure = pulseIn(ECHO_PIN, HIGH);
  
 /* 3. Calcul la distance à partir du temps mesuré */
 float distance_cm = measure*0.034/2;
 Serial.print("temps: ");
 Serial.println(measure);
 Serial.print("Distance: ");
 Serial.println(distance_cm);
 delay(500);
 
 if (distance_cm < distmin)

 {  digitalWrite(led,HIGH) ;
    digitalWrite(INA1,HIGH);
    digitalWrite(INA2,LOW);
    analogWrite(PWMA,0);
    digitalWrite(INB1,HIGH);
    digitalWrite(INB2,LOW);
    analogWrite(PWMB,200);
    delay(1000);
    analogWrite(PWMA,200);
   
 }
 else {
   if(Serial.available()>0)
   {
   unsigned char actions=Serial.read();
   digitalWrite(STANDBY,HIGH);
   digitalWrite(INA1,HIGH);
   digitalWrite(INA2,LOW);
   digitalWrite(INB1,HIGH);
   digitalWrite(INB2,LOW);
   
   if(actions == 48)//avance
    {
      analogWrite(PWMA,200);
      analogWrite(PWMB,200);
    }
    else if (actions == 50)//tourne droite
    { 
      analogWrite(PWMA,0);
      analogWrite(PWMB,200);
      delay(1000);
      analogWrite(PWMA,200);
      
    }
    else if (actions == 51)//tourne gauche
    {
      analogWrite(PWMA,200); 
      analogWrite(PWMB,0);
      delay(1000);
      analogWrite(PWMB,200);
      
    }
    else if (actions == 49)//Recule
    {
      digitalWrite(INA1,LOW);
      digitalWrite(INA2,HIGH);
      analogWrite(PWMA,200);
      digitalWrite(INB1,LOW);
      digitalWrite(INB2,HIGH);
      analogWrite(PWMB,200);
    }
    
    else if (actions == 2)//tourne gauche
    { digitalWrite(TRIGGER_PIN, LOW);
      analogWrite(PWMA,0);
      analogWrite(PWMB,0);
      
    }

  }
 }
}
